"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Player = exports.Player = function Player(game, spawnPoint) {
    _classCallCheck(this, Player);

    if (!spawnPoint) {
        spawnPoint = new BABYLON.Vector3(0, 10, -10);
    }

    this.spawnPoint = spawnPoint;
    this.scene = game.scene;
    this.game = game;
    this.height = 2;
    this.speed = 1;
    this.inertia = 0.9;
    this.angularInertia = 0;
    // The mouse sensibility (lower the better sensible)
    this.angularSensibility = 1000;
    this.camera = this._initCamera();
    // The player must click on the canvas to activate control
    this.controlEnabled = false;
    this.weapon = new Weapon(game, this);
};
