class MagritteMan extends BABYLON.Mesh {

    constructor(kind, game) {

        super("target", game.scene); //BABYLON.Mesh.call(this, "target", game.scene);
        this.game = game;
        this.kind = kind;
        this.health = 4;
        this.speed = 0.4;

        var vd = BABYLON.VertexData.CreateCylinder(42, 20, 12);
        vd.applyToMesh(this, false);

        var ma = new BABYLON.StandardMaterial(`z_${kind}`, game.scene);
        ma.diffuseTexture = new BABYLON.Texture(`assets/paintings/magritte_${kind}.jpg`, game.scene);
        this.material = ma;
    
        this.position = new BABYLON.Vector3(
            Math.random() * game.size,
            this.kind === 'pigeon' ? 22 : 220, 
            Math.random() * game.size
        );
        console.log(this.position);

        // Check collisions
        this.checkCollisions = true;

        this.game.scene.registerBeforeRender(() => {
            this.position.y += this.speed * ( this.kind === 'pigeon' ? 1 : -1);

        });
    }

    explode() {
        if (this.game.human) {
            this.game.human.help += this.health;
        }
        this.dispose();
    }
};