class PaintingEgg extends BABYLON.Mesh {

    constructor(game, painting, posX, posZ) {

        super("target", game.scene); //BABYLON.Mesh.call(this, "target", game.scene);
        this.game = game;
        this.painting = painting;

        var vd = BABYLON.VertexData.CreateSphere(48, 39);
        vd.applyToMesh(this, false);

        var m = new BABYLON.StandardMaterial(painting.name, game.scene);
        m.diffuseTexture = new BABYLON.Texture(`assets/paintings/${this.assetName(painting.name)}.jpg`, game.scene);
        this.material = m;

        this.position = new BABYLON.Vector3(posX, 34, posZ);

        // Check collisions
        this.checkCollisions = true;
        let u = 0;

        this.game.scene.registerBeforeRender(() => {
            // this.rotation.y += Math.random() * 4 - 8;
            if (this.human === null) {
                this.rotation.x += Math.random() * 0.08
            } else { // flying away
                this.rotation.x += Math.random() * 0.12
                this.position.y += 0.05 + u * 0.02;
                u += 1;
            }
        });
        this.human = null;
    }

    explode() {
        if (this.human === null) {
            this.human = this.game.human = new PaintingHuman(
                this.game, 
                this.painting, 
                this.position.x + 12,
                this.position.z + 12);
            this.game.eggsCracked += 1;
            
            let cam = this.game.scene.activeCameras[0];
            let x, z;
            if (cam.position.x <= this.human.position.x) {
                x = this.game.size - 200;
            } else {
                x = 82;
            }
            if (cam.position.z <= this.human.position.z) {
                z = this.game.size - 200;
            } else {
                z = 60;
            }

            this.game.wall = new Wall(
                this.game, 
                this.painting, 
                x,
                z);

            this.human.begin = Date.now();
            this.human.help = 0;
            this.human.memory = 100;
            this.human.xDistance = (x - this.human.position.x) / 20;
            this.human.yDistance = (22 - this.human.position.y) / 20;
            this.human.zDistance = (z - this.human.position.z) / 20;


            setTimeout(() => this.dispose(), 4000)
        } else {
            console.log('COMICS', 'you shouldn\'t kill those who lay eggs');
            // var sm = new BABYLON.StandardMaterial(`skyBox_${this.painting.name}`, this.game.scene);
            this.game.skybox.material.reflectionTexture = new BABYLON.CubeTexture(`assets/paintings/${this.assetName(this.painting.name)}_heaven`, this.game.scene);
            // sm.diffuseTexture = new BABYLON.Texture(`assets/paintings/${this.painting.name}_heaven.jpg`, this.game.scene);
            // this.game.skybox.material = sm;
        }
    }

    assetName(name) {
        return name.replace(' ', '_');
    }
};