class PaintingHuman extends BABYLON.Mesh {

    constructor(game, painting, posX, posZ) {

        
        super("target", game.scene);
        this.game = game;
        this.painting = painting;
        
        var vd = BABYLON.VertexData.CreateBox(9);
        vd.applyToMesh(this, false);
        this.scaling.x = 0.2;
        this.scaling.y = 1.6;
        this.scaling.z = 1.8;
        this.rotation.x = 1.58;
        this.showBoundingBox=false;
        //Define a material
        var ma = new BABYLON.StandardMaterial(painting.name, game.scene);
        // ma.emissiveColor = new BABYLON.Color3(0, 0, 1);
        // ma.opacityTexture = new BABYLON.Texture(`assets/paintings/${this.assetName(painting.name)}_human.jpg`, game.scene);
        ma.diffuseTexture = new BABYLON.Texture(`assets/paintings/${this.assetName(painting.name)}_human.jpg`, game.scene);
        ma.diffuseTexture.hasAlpha = true;        
        // ma.alpha = 0.9;
        ma.useAlphaFromDiffuseTexture = true;
        ma.backFaceCulling = false;
        var ba = new BABYLON.StandardMaterial("material1", game.scene);
        ba.diffuseColor = new BABYLON.Color3(1,1,1);
        
        var multi = new BABYLON.MultiMaterial("a", game.scene);
        multi.subMaterials = [ba, ba, ma, ma, ba, ba];
    
        var verticesCount=this.getTotalVertices();
        this.subMeshes = [new BABYLON.SubMesh(0, 0, verticesCount, 0, 6, this),
                          new BABYLON.SubMesh(1, 1, verticesCount, 6, 6, this),
                          new BABYLON.SubMesh(2, 2, verticesCount, 12, 6, this),
                          new BABYLON.SubMesh(3, 3, verticesCount, 18, 6, this),
                          new BABYLON.SubMesh(4, 4, verticesCount, 24, 6, this),
                          new BABYLON.SubMesh(5, 5, verticesCount, 30, 6, this)];

        this.material=multi;

        // this.material = m;

        this.position = new BABYLON.Vector3(posX, 8, posZ);

        // Check collisions
        this.checkCollisions = true;

        this.rotations = [];
        for(let j = 0;j < 32; j ++) {
            this.rotations[j] = Math.random() * 8 - 4;
        }
        
        var h = 16;
        var period = 5;
        var z = 0;

        this.check = setInterval(() => {
            var time = Date.now() - this.begin;
            if (time > (this.game.remainingTime + this.help) * 1000) {
                window.simulator.end('no time');
            }
            else if (z % period == 0) {
                let left = this.timeLeft(Date.now());
                console.log(`Left ${left}`);
                if (this.material.subMaterials[3]) {
                    this.material.subMaterials[3].alpha = left / this.game.remainingTime;
                    this.material.subMaterials[4].alpha = left / this.game.remainingTime;
                }
            }
            z += 1;
        }, 1000);

        this.game.scene.registerBeforeRender(() => {
            if (h % 16 == 0) {
                // this.rotation.y += this.rotations[(h / 16 + 46)% 32];
                // this.rotation.x += this.rotations[(h / 16 + 2)% 32];
                this.position.z += this.rotations[(h / 16 + 46)% 32];
                this.position.x += this.rotations[(h / 16 + 46)% 32];
            }
            h += 1;
        });
        this.human = null;

        //talk stuff

        // this.memory = 100;
        this.lastHit = 0;
    }

    explode() {
        // if (this.lastHit +  this.game.memory.protectedTime * 1000 < Date.now()) { //ms
            this.position.x += this.xDistance;
            this.position.y += this.yDistance;
            this.position.z += this.zDistance;

            // this.memory -= (100 / this.game.memory.memento);
            this.lastHit = Date.now();

            if (this.timeLeft(Date.now()) < 0) {
                // this.target.material = this.target.xMaterial;
                //if hit
                this.dispose();
                window.simulator.end('memory lost');
            }
        // }
    }

    timeLeft(time) {
        return - Math.floor(time / 1000 - this.begin / 1000 - (this.game.remainingTime + this.help));
    }

    assetName(name) {
        return name.replace(' ', '_');
    }
};