class Target extends BABYLON.Mesh {

    constructor(game, painting, posX, posZ) {

        
        super("target", game.scene); //BABYLON.Mesh.call(this, "target", game.scene);
        this.game = game;
        this.painting = painting;
        window.paintings.push(this);

        // var vd = BABYLON.VertexData.CreateBox(1);
        // var vd = BABYLON.Mesh.CreateBox(painting.name, 28, game.scene);
        var vd = BABYLON.VertexData.CreateBox(18, 10, 18 * 2.2);
        // vd.scaling.x = 0.4;
        // vd.scaling.z = 0.22;
        vd.applyToMesh(this, false);

        // debugger;
        var m = new BABYLON.StandardMaterial(painting.name, game.scene);
        m.diffuseTexture = new BABYLON.Texture(`assets/paintings/${this.assetName(painting.name)}.jpg`, game.scene);
        this.material = m;

        this.position = new BABYLON.Vector3(posX, 8, posZ);

        // Check collisions
        this.checkCollisions = true;

        this.rotations = [];
        for(let j = 0;j < 32; j ++) {
            this.rotations[j] = Math.random() * 0.2 - 0.1;
        }
        
        var h = 16;
        this.game.scene.registerBeforeRender(() => {
            if (h % 16 == 0 ) {
                this.rotation.y += this.rotations[(h / 16 + 46)% 32];
                // this.rotation.x += this.rotations[(h / 16 + 2)% 32];
            }
            h += 1;
        });
        this.human = null;

        this.memory = 100;
        this.lastHit = 0;
    }

    explode() {
        // we become gray
        // the human goes out as a target
        // the heaven gets our background
        this.xMaterial = this.material;
        this.material = undefined;


        this.humans = [];
        for(let i=0; i < 10;i++) {
            this.humans.push(
                new PaintingHuman(this.game, this.painting, this, Math.random() * 320 - 160, Math.random() * 400 - 200));
        }            
        // let sm = new BABYLON.StandardMaterial(`skybox_${this.painting.name}`, this.game.scene);
        // this.game.skybox.material.reflectionTexture = 
        for(let cloud of this.game.clouds) {
            cloud.material.diffuseTexture = new BABYLON.Texture(`assets/paintings/${this.assetName(this.painting.name)}_heaven.jpg`, scene);
        }        
        // new BABYLON.CubeTexture(`assets/paintings/${this.assetName(this.painting.name)}_heaven`, this.game.scene);
        // this.game.skybox.material = sm;
        this.dispose();
    }

    assetName(name) {
        return name.replace(' ', '_');
    }
};