class Wall extends BABYLON.Mesh {

    constructor(game, painting, posX, posZ) {

        super("target", game.scene); //BABYLON.Mesh.call(this, "target", game.scene);
        this.game = game;
        this.painting = painting;

        var vd = BABYLON.VertexData.CreateBox(350);
        vd.applyToMesh(this, false);

        this.scaling.y = 0.4;
        this.scaling.z = 0.01;
        var ma = new BABYLON.StandardMaterial(painting.name, game.scene);
        ma.diffuseColor = new BABYLON.Color3(0, 1, 0);
        ma.alpha = 0.2;
        this.material = ma;

        this.position = new BABYLON.Vector3(posX, 22, posZ);

        // Check collisions
        this.checkCollisions = true;

        // this.game.scene.registerBeforeRender(() => {
        //     this.rotation.y += Math.random() * 4 - 8;
        //     this.rotation.x += Math.random() * 4 - 8;
        // });
        this.human = null;
    }

    explode(e) {
    	if (this.game.human.intersectsMesh(this)) {
    		clearInterval(this.game.human.check);
            this.game.human.dispose();
    		this.game.human = null;

    		let u = this.game.eggs[this.game.eggsCracked];
    		this.game.eggs[this.game.eggsCracked] = new PaintingEgg(
                    this.game,
                    u.painting,
                    u.posX,
                    u.posZ
                );
            
    		this.dispose();
    	}
    }
};